<?php declare(strict_types=1);
/**
 * This file is part of the SplendidBear Websites' projects.
 *
 * Copyright (c) 2026 @ www.splendidbear.org
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

/*
 * This file is part of the SplendidBear Websites' projects.
 *
 * Copyright (c) 2026 @ www.splendidbear.org
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace App\Service\Email;

use App\Entity\User;
use DateTime;
use Exception;
use Psr\Log\LoggerInterface;
use RuntimeException;
use Symfony\Bridge\Twig\Mime\TemplatedEmail;
use Symfony\Component\DependencyInjection\Attribute\Autowire;
use Symfony\Component\Mailer\Exception\TransportExceptionInterface;
use Symfony\Component\Mailer\MailerInterface;

/**
 * Class SendUserActivationNotificationService
 *
 * @package  App\Service\Email
 * @author   Lang <https://www.splendidbear.org>
 * @category Class
 * @license  https://www.gnu.org/licenses/lgpl-3.0.en.html GNU Lesser General Public License
 * @link     www.splendidbear.org
 * @since    2026. 04. 20.
 */
readonly final class SendUserActivationNotificationService
{
    public function __construct(
        #[Autowire(env: 'APP_CONTACT_MAIL_ADDRESS')]
        private string          $appContactMailAddress,
        private LoggerInterface $logger,
        private MailerInterface $mailer,
    ) {
    }

    public function send(User $user, DateTime $activatedAt): void
    {
        try {
            $this->mailer->send(
                new TemplatedEmail()
                    ->from('noreply@mineseeker.hu')
                    ->to($this->appContactMailAddress)
                    ->subject("✅ User Account Activated: {$user->getUsername()}")
                    ->htmlTemplate('emails/user_activation_notification.html.twig')
                    ->context([
                        'user'        => $user,
                        'activatedAt' => $activatedAt,
                    ])
            );
        } catch (TransportExceptionInterface|Exception $e) {
            $this->logger->error("Failed to send user activation notification: {$e->getMessage()}", [
                'exception' => $e,
                'user'      => $user->getUsername(),
            ]);
            throw new RuntimeException("Failed to send user activation notification: {$e->getMessage()}");
        }
    }
}

